create table renkaat (
        koodi           integer primary key,
        valmistaja      varchar2(64),
        tyyppi          varchar2(64) )
/
create table aika (
        alkamisaika     date,
        loppumisaika    date,
        ekakoodi        integer,
        tokakoodi       integer,
        tyyppi          integer not null references aikasuhteet(tyyppi),
	kerta		integer )
/
create table aikasuhteet(
        tyyppi          integer primary key,
        ensimmainen     varchar2(64) not null,
        toinen          varchar2(64) not null )
/
create table talli(
        koodi           integer primary key,
        nimi            varchar2(128),
        kotipaikka      varchar2(256),
        perustettu      date,
        paallikko       varchar2(128),
        liikevaihto     integer )
/
create table moottori(
        koodi           integer primary key,
        tyyppi          varchar2(128),
        vuosimalli      date,
        teho            number,
	valmistaja	varchar2(128) )
/
create table sarja(
        koodi           integer primary key,
        vuosi           varchar2(64) )
/
create table tallisarja(
        tallikoodi      integer not null references talli(koodi),
        sarjakoodi      integer not null references sarja(koodi) )
/
create table rata (
        koodi           integer primary key,
        nimi            varchar2(512),
        sijainti        varchar2(512),
        pituus          number,
        ennatys         number,
        vvuosi          integer,
        kuvaURL         varchar(256) )

/
create table kilpailu(
        koodi           integer primary key,
        rata            integer not null references rata(koodi),
        aajo            date,
        kilpailu        date,
	sarja		integer references sarja(koodi) )
/
create table tapaustyyppi(
        tyyppi          integer primary key,
        kuvaus          varchar2(512))
/
create table tapaus(
        koodi           integer primary key,
        kilpailu        integer not null references kilpailu(koodi),
        aika            number,
        tyyppi          integer not null references tapaustyyppi(tyyppi),
	kuljettaja	integer references kuljettaja(koodi) )
/
create table kuljettaja(
        koodi           integer primary key,
        enimi           varchar2(128),
        snimi           varchar2(128),
        saika           date,
        spaikka         varchar2(512),
        kaika           date,
        kpaikka         varchar2(512),
        kansalaisuus    varchar2(512),
        kotipaikka      varchar2(512),
        kuvaURL         varchar2(256) )
/
create table tulos(
        kuljettaja      integer references kuljettaja(koodi),
        kilpailu        integer references kilpailu(koodi),
        aatulos         number,
  	ktulos		number,
	pisteet		integer default 0,
	primary key(kuljettaja,kilpailu) )
/
create table kauttaja(
        tunnus          integer primary key,
        nimi            varchar2(64) unique not null,
        ssana           varchar2(64) )
/
create table istunto(
        tunnus          integer references kauttaja(tunnus),
        istuntot        varchar2(64) unique not null,
        vanhenee        date )
/
