CREATE OR replace PROCEDURE kilpailuaseta(tnappi IN VARCHAR2,
					  kkoodi IN INTEGER,
					  krata IN INTEGER,
					  kaaaika IN VARCHAR2 DEFAULT NULL,
					  kaika IN VARCHAR2 DEFAULT NULL )
IS
   tsarja INTEGER;
BEGIN
   IF NOT autentikoi THEN 
      RETURN  ;
   END IF;
   
   SELECT sarja INTO tsarja FROM kilpailu WHERE koodi=kkoodi;
   
   IF tnappi='Pivit' THEN
      IF to_date(kaika,'DD.MM.YYYY')<to_date(kaaaika,'DD.MM.YYYY') THEN
	 raise_application_error(-20104,'Kilpailu ennen aika-ajoa!');
      END IF;
      UPDATE kilpailu SET rata=krata, aajo=to_date(kaaaika,'DD.MM.YYYY'),
	kilpailu=to_date(kaika,'DD.MM.YYYY') WHERE koodi=kkoodi;
   ELSIF tnappi = 'Poista' THEN
      DELETE kilpailu WHERE koodi=kkoodi;
      
   END IF;
   
   sarjasyott(tsarja);
   
EXCEPTION
   WHEN OTHERS THEN
     
     IF sqlcode = -20104 THEN
	otsikko('Virheellinen ajojrjestys!');
        htp.p('Aika ajo ei voi olla '||kaaaika||' jos kilpailu on jo ');
	htp.p(kaika||'.');
     ELSIF sqlcode = -1847 THEN
	otsikko('Virheellinen pivmr!');
	htp.p('Jokin antamasi pivmr oli vrn muotoinen. Pivmrt ');
	htp.p(' pit antaa muodossa '||to_char(sysdate,'DD.MM.YYYY')||'.');
     ELSIF sqlcode = -1858 THEN
	otsikko('Teksti numerokentss!');
	htp.p('Jossain kentss, johon pit kirjoittaa luku, on muita kuin');
	htp.p(' numeroja.');
     ELSE 
	htp.p('<h3>Proseduuri kilpailuaseta suoritus pttyi virheeseen:</h3>');
	htp.p('<font color=red>'|| sqlerrm || '</font>');
     END IF;
     
     htp.para;
     htp.p('Muutoksia ei ole talletettu tietokantaan!');
     paate;
END;
/
show errors
  GRANT execute ON kilpailuaseta TO www_user;
EXIT
  
