CREATE OR replace PROCEDURE kilpailusivu(kkoodi IN INTEGER)
IS
   cursor tamakisa IS SELECT kilpailu.koodi,aajo,kilpailu,sarja,nimi,sijainti,
     pituus,ennatys,vvuosi,rata 
     FROM  kilpailu,rata 
     WHERE kilpailu.rata=rata.koodi AND kilpailu.koodi=kkoodi;
   cursor lahtojarj IS SELECT k.koodi,k.enimi,k.snimi,k.saika,k.spaikka,
     k.kaika,k.kpaikka,k.kansalaisuus,k.kotipaikka,talli.nimi tnimi,pisteet,
     ktulos,aatulos,talli.koodi tkoodi
     FROM kuljettaja k,talli,tallisarja,kilpailu kplu,aika,tulos
     WHERE  kplu.koodi=kkoodi
     AND tulos.kuljettaja=k.koodi AND
     tulos.kilpailu=kplu.koodi AND
     tallisarja.sarjakoodi=kplu.sarja AND 
     tallisarja.tallikoodi=talli.koodi AND 
     aika.tyyppi=(SELECT tyyppi FROM aikasuhteet 
     WHERE ensimmainen='kuljettaja' AND toinen='talli') AND
     aika.alkamisaika<kplu.aajo AND 
     (aika.loppumisaika IS NULL OR aika.loppumisaika>kplu.kilpailu)
     AND aika.ekakoodi=k.koodi AND 
     aika.tokakoodi=talli.koodi
     ORDER BY tulos.aatulos;
   
   cursor lopputulokset IS SELECT k.koodi,k.enimi,k.snimi,k.saika,k.spaikka,
     k.kaika,k.kpaikka,k.kansalaisuus,k.kotipaikka,talli.nimi tnimi,pisteet,
     ktulos,aatulos,talli.koodi tkoodi
     FROM kuljettaja k,talli,tallisarja,kilpailu kplu,aika,tulos
     WHERE  kplu.koodi=kkoodi
     AND tulos.kuljettaja=k.koodi AND
     tulos.kilpailu=kplu.koodi AND
     tallisarja.sarjakoodi=kplu.sarja AND 
     tallisarja.tallikoodi=talli.koodi AND 
     aika.tyyppi=(SELECT tyyppi FROM aikasuhteet 
     WHERE ensimmainen='kuljettaja' AND toinen='talli') AND
     aika.alkamisaika<kplu.aajo AND 
     (aika.loppumisaika IS NULL OR aika.loppumisaika>kplu.kilpailu)
     AND aika.ekakoodi=k.koodi AND 
     aika.tokakoodi=talli.koodi
     ORDER BY tulos.ktulos;
   
   cursor etapaukset IS SELECT koodi,kilpailu,aika,kuljettaja,kuvaus
     FROM tapaus t,tapaustyyppi tp
     WHERE t.tyyppi=tp.tyyppi AND t.kilpailu=kkoodi
     ORDER BY aika DESC;
   TYPE taustavari IS TABLE OF VARCHAR2(20) INDEX BY binary_integer;
   taustat taustavari;
   
   vaika NUMBER;
   etapaus etapaukset%ROWTYPE;
   tunari kuljettaja%ROWTYPE;
   kuski lahtojarj%ROWTYPE;
   tama tamakisa%ROWTYPE;
   tsarja INTEGER;
   counter INTEGER;
BEGIN
   -- Hieno kysely menossa olevan sarjan valinnaksi.
   BEGIN 
      SELECT k.sarja INTO tsarja FROM kilpailu k 
	WHERE ABS(sysdate-k.kilpailu)= (SELECT min(ABS(sysdate-a.kilpailu)) FROM
	kilpailu a );
   EXCEPTION
      WHEN no_data_found THEN
	tsarja:=NULL;
   END;
   open tamakisa;
   fetch tamakisa INTO tama;

   otsikko(tama.sijainti||':n osakilpailu '||to_char(tama.kilpailu,'DD.MM.YYYY'));
   
   htp.tableopen(NULL,NULL,NULL,NULL,'width=90% border=4');
   htp.tabledata('<a href=ops$kpalin.kalenteri?skoodi='||tsarja||'>Kalenteri</a>','center');
   htp.tabledata('<a href=ops$kpalin.sarjasivu?skoodi='||tsarja||'>Sarja</a>','center');
   htp.tabledata('<a href=ops$kpalin.tallit>Tallit</a>','center');
   htp.tabledata('<a href=ops$kpalin.kuljettajat>Kuljettajat</a>','center');
   htp.tableclose;
   htp.line;
   
   
   htp.tableopen;
   htp.tablerowopen;
   htp.tabledata('Sijainti:');
   htp.tabledata(tama.sijainti);
   htp.tablerowclose;
   htp.tablerowopen;
   htp.tabledata('Radan nimi:');
   htp.tabledata('<a href=ops$kpalin.ratasivu?rkoodi='||tama.rata||'>'||tama.nimi||
     '</a>');
   htp.tablerowclose;
   htp.tablerowopen;
   htp.tabledata('Aika ajot:');
   htp.tabledata(to_char(tama.aajo,'DD.MM.YYYY'));
   htp.tablerowclose;
   htp.tablerowopen;
   htp.tabledata('Varsinainen kilpailu:');
   htp.tabledata(to_char(tama.kilpailu,'DD.MM.YYYY'));
   htp.tableclose;
   taustat(2):='bgcolor=#99cccc';
   taustat(1):=NULL;
   
   counter:=1;
   
   htp.line;
   htp.p('Lhtjrjestys');
   
   htp.tableopen(NULL,'center',NULL,NULL,'width=75%');
   FOR kuski IN lahtojarj LOOP
      htp.tablerowopen;
      htp.tabledata(counter,NULL,NULL,NULL,NULL,NULL,taustat(MOD(counter,2)+1));
      

      htp.tabledata('<a href=ops$kpalin.kuljettajasivu?kkoodi='||kuski.koodi||'>'||kuski.enimi||' '||kuski.snimi||'</a> (<a href=ops$kpalin.tallisivu?tkoodi='||kuski.tkoodi||'>'||kuski.tnimi||'</a>)',NULL,NULL,NULL,NULL,NULL,taustat(MOD(counter,2)+1));
      htp.tabledata(aikamuoto(kuski.aatulos),'right',NULL,NULL,NULL,NULL,taustat(MOD(counter,2)+1));
      htp.tablerowclose;
      counter:=counter+1;
   END LOOP;
   htp.tableclose;
   
   
   htp.line;
   BEGIN 
      SELECT min(ktulos)
	INTO vaika 
	FROM tulos 
	WHERE kilpailu=kkoodi;
   EXCEPTION
      WHEN no_data_found THEN
	vaika:=NULL;
   END;
   counter:=1;
   htp.p('Lopputulokset:');
   
   
   htp.tableopen(NULL,'center',NULL,NULL,'width=75%');
   FOR kuski IN lopputulokset LOOP
      htp.tablerowopen;
      htp.tabledata(counter,NULL,NULL,NULL,NULL,NULL,taustat(MOD(counter,2)+1));
      htp.tabledata('<a href=ops$kpalin.kuljettajasivu?kkoodi='||kuski.koodi||'>'||kuski.enimi||' '||kuski.snimi||'</a> (<a href=ops$kpalin.tallisivu?tkoodi='||kuski.tkoodi||'>'||kuski.tnimi||'</a>)',NULL,NULL,NULL,NULL,NULL,taustat(MOD(counter,2)+1));
      htp.tabledata(kuski.pisteet||'p','right',NULL,NULL,NULL,NULL,taustat(MOD(counter,2)+1));
      IF counter=1 THEN
	 htp.tabledata(aikamuoto(kuski.ktulos),'right',NULL,NULL,NULL,NULL,taustat(MOD(counter,2)+1));
      ELSE
	 htp.tabledata('+'||aikamuoto(kuski.ktulos-vaika),'right',NULL,NULL,NULL,NULL,taustat(MOD(counter,2)+1));
      END IF;
      
      htp.tablerowclose;
      counter:=counter+1;
   END LOOP;
   htp.tableclose;
   htp.line;
   htp.p('Kilpailun pytkirjamerkinnt:');
   htp.ulistopen;
   FOR etapaus IN etapaukset LOOP
      htp.p('<li>'||etapaus.kuvaus||' '||aikamuoto(etapaus.aika));
      IF etapaus.kuljettaja IS NOT NULL THEN
	 SELECT * INTO tunari FROM kuljettaja WHERE koodi=etapaus.kuljettaja;
	 htp.p('(<a href=ops$kpalin.kuljettajasivu?kkoodi='||tunari.koodi||
	   '>'||tunari.enimi||' '||tunari.snimi||'</a>)');
      END IF;
   END LOOP;
   htp.ulistclose;
   
   paate;
EXCEPTION
   WHEN OTHERS THEN
     htp.p('<h3>Proseduuri kilpailusivu suoritus pttyi virheeseen:</h3>');
     htp.p('<font color=red>'|| sqlerrm || '</font>');
END;
/
show errors
  GRANT execute ON kilpailusivu TO www_user;
EXIT
