CREATE OR replace PROCEDURE kilpailusyott(kkoodi IN INTEGER)  IS
   cursor kisainfot IS SELECT sarja.vuosi, k.koodi,k.aajo, k.kilpailu, r.nimi,
     r.sijainti
     FROM sarja, kilpailu k ,rata r 
     WHERE k.koodi=kkoodi AND sarja.koodi=k.sarja AND k.rata=r.koodi;
   cursor osallistujat IS SELECT k.koodi,k.enimi,k.snimi,k.saika,k.spaikka,
     k.kaika,k.kpaikka,k.kansalaisuus,k.kotipaikka,talli.nimi tnimi
     FROM kuljettaja k,talli,tallisarja,kilpailu kplu,aika
     WHERE kplu.koodi=kkoodi AND 
     tallisarja.sarjakoodi=kplu.sarja AND 
     tallisarja.tallikoodi=talli.koodi AND 
     aika.tyyppi=(SELECT tyyppi FROM aikasuhteet 
     WHERE ensimmainen='kuljettaja' AND toinen='talli') AND
     aika.alkamisaika<kplu.aajo AND 
     (aika.loppumisaika IS NULL OR aika.loppumisaika>kplu.kilpailu)
     AND aika.ekakoodi=k.koodi AND 
     aika.tokakoodi=talli.koodi
     ORDER BY tnimi,snimi;
   cursor eriktapahtumat IS SELECT koodi,aika,kuvaus,kuljettaja
     FROM tapaus t,tapaustyyppi ty
     WHERE t.tyyppi=ty.tyyppi AND t.kilpailu=kkoodi;
   
   etapaus eriktapahtumat%ROWTYPE;
   kisainfo kisainfot%ROWTYPE;
   osall osallistujat%ROWTYPE;
   tul tulos%ROWTYPE;
   tunari kuljettaja%ROWTYPE;
BEGIN
   IF NOT autentikoi THEN 
      RETURN  ;
   END IF; 
   open kisainfot;
   
   fetch kisainfot INTO kisainfo;
   
   otsikko(kisainfo.vuosi||'-sarjassa ajettava '||kisainfo.sijainti||
     ':n osakilpailu',true);
   htp.tableopen;
   htp.tablerowopen;
   htp.tabledata('Paikka:');
   htp.tabledata(kisainfo.nimi||', '||kisainfo.sijainti);
   htp.tablerowclose;
   htp.tablerowopen;
   htp.tabledata('Aika-ajot:');
   htp.tabledata(to_char(kisainfo.aajo,'DD.MM.YYYY'));
   htp.tablerowclose;
   htp.tablerowopen;
   htp.tabledata('Kilpailu:');
   htp.tabledata(to_char(kisainfo.kilpailu,'DD.MM.YYYY'));
   htp.tableclose;
   
   htp.line;
   
   htp.tableopen;
   htp.tableheader('Talli',NULL,NULL,NULL,NULL,'40');
   htp.tableheader('Kuljettaja',NULL,NULL,NULL,NULL,'60');
   htp.tableheader('Aika-ajo',NULL,NULL,NULL,NULL,'20');
   htp.tableheader('Kilpailu',NULL,NULL,NULL,NULL,'20');
   htp.tableheader('Pisteet',NULL,NULL,NULL,NULL,'20');
   
   FOR osall IN osallistujat LOOP
      htp.tablerowopen;
      htp.tabledata(osall.tnimi,NULL,NULL,NULL,NULL,'40');
      htp.tabledata('<a href=ops$kpalin.kisatietosyott?kuljk='||osall.koodi
	||'&'||'kisak='||kkoodi||'>'||osall.enimi||' '||osall.snimi||'</a>'
	,NULL,NULL,NULL,NULL,'60');
      BEGIN
	 SELECT * INTO tul FROM tulos WHERE kilpailu=kkoodi AND 
	   kuljettaja=osall.koodi;
	 htp.tabledata(aikamuoto(tul.aatulos),'right',NULL,NULL,NULL,'20');
	 htp.tabledata(aikamuoto(tul.ktulos),'right',NULL,NULL,NULL,'20');
	 htp.tabledata(tul.pisteet,'right',NULL,NULL,NULL,'20');
      EXCEPTION
	 WHEN no_data_found THEN 
	   htp.tabledata(NULL,NULL,NULL,NULL,NULL,'20');
	   htp.tabledata(NULL,NULL,NULL,NULL,NULL,'20');
	   htp.tabledata(NULL,NULL,NULL,NULL,NULL,'20');
      END;
	
      htp.tablerowclose;
   END LOOP;
   htp.tableclose;
   
   htp.line;
   htp.p('Kilpailussa tapahtuneet erikoisuudet:');
   htp.ulistopen;
   
   FOR etapaus IN eriktapahtumat LOOP
      htp.p('<li><a href=ops$kpalin.etapaussyott?etapaus='||etapaus.koodi||'&'||
	'kisak='||kkoodi||
	'>'||aikamuoto(etapaus.aika)||': '||etapaus.kuvaus);
      IF etapaus.kuljettaja IS NOT NULL THEN
	 SELECT * INTO tunari FROM kuljettaja WHERE koodi=etapaus.kuljettaja;
	 htp.p(tunari.enimi||' '||tunari.snimi);
      END IF;
      htp.p('</li>');
   END LOOP;
   
   htp.listitem('<a href=ops$kpalin.etapaussyott?kisak='||kkoodi||'>Lis uusi tapahtuma.');
   htp.ulistclose;
   
   htp.line;
   htp.anchor('ops$kpalin.paasivu','Psivulle');
   paate ;

EXCEPTION
   WHEN OTHERS THEN
     htp.p('<h3>Proseduuri kilpailusyott suoritus pttyi virheeseen:</h3>');
     htp.p('<font color=red>'|| sqlerrm || '</font>');
END;
/
show errors
  GRANT execute ON kilpailusyott TO www_user;
EXIT
  
