CREATE OR replace PROCEDURE kisatietoasett(kisak IN INTEGER,
					   kuljk IN INTEGER,
					   aaaika IN NUMBER DEFAULT NULL,
					   kisaaika IN NUMBER DEFAULT NULL,
					   knappi IN VARCHAR2 DEFAULT NULL)
IS
BEGIN
   IF NOT autentikoi THEN 
      RETURN  ;
   END IF;
   
   IF knappi='Lis' OR knappi='Pivit' THEN
      IF aaaika<0 THEN
	 raise_application_error(-20105,'Aika-ajoissa valoa nopeampi.');
      END IF;
      IF kisaaika<0 THEN
	 raise_application_error(-20106,'Kisassa valoa nopeampi.');
      END IF;
   END IF;
   
   IF knappi='Lis' THEN 
      INSERT INTO tulos VALUES(kuljk,kisak,aaaika,kisaaika,0);
   ELSIF knappi='Poista' THEN
      DELETE tulos WHERE kuljettaja=kuljk AND kilpailu=kisak;
   ELSIF knappi='Pivit' THEN
      UPDATE tulos SET aatulos=aaaika, ktulos=kisaaika 
	WHERE kuljettaja=kuljk AND kilpailu=kisak;
   ELSE
      otsikko('Jotain pahasti vialla.');
      htp.p('Olet tainnut viritell omiasi. Tnne sinulla ei ole mitn asiaa.');
      paate;
   END IF;
   
   laske_pisteet(kisak);
   
   kilpailusyott(kisak);

EXCEPTION
   WHEN OTHERS THEN
     IF sqlcode = -20105 THEN
     otsikko('Virheellinen aika-ajotulos!');
     htp.p('Annoit negatiivisen arvon aika-ajotulokseksi.');
     
     ELSIF sqlcode=-20106 THEN
	otsikko('Virheellinen kilpailutulos!');
	htp.p('Annoit negatiivisen arvon kilpailutulokseksi.');
     ELSE
	otsikko('Virhe!');
	htp.p('<h3>Proseduuri kisatietoasett suoritus pttyi virheeseen:</h3>');
	htp.p('<font color=red>'|| sqlerrm || '</font>');
     END IF;
     
     htp.p('Tietokantaa ei ole muutettu!');
     paate;
END;
/
show errors
  GRANT execute ON kisatietoasett TO www_user;
EXIT
  

