CREATE OR replace PROCEDURE kuljaseta 
  (kenimi IN VARCHAR2, 
  ksnimi IN VARCHAR2, 
  ksaika IN VARCHAR2,
  kspaikka IN VARCHAR2,
  kkaika IN VARCHAR2,
  kkpaikka IN VARCHAR2,
  kkansalaisuus IN VARCHAR2,
  kkotipaikka IN VARCHAR2,
  kkuva IN VARCHAR2,
  knappi IN VARCHAR2,
  kkoodi IN INTEGER,
  tallikoodi IN INTEGER,
  tallialku IN VARCHAR2 DEFAULT NULL,
  talliloppu IN VARCHAR2 DEFAULT NULL)  
IS
   uusikoodi INTEGER := kkoodi;
   aputyyppi INTEGER;
BEGIN
   IF NOT autentikoi THEN 
      RETURN  ;
   END IF; 
   
   
   savepoint kuljaseta_transa;
      
      
   IF uusikoodi IS NULL OR uusikoodi<0 THEN
      SELECT max(koodi)+1 INTO uusikoodi FROM kuljettaja;
   END IF;
   IF uusikoodi IS NULL THEN 
      uusikoodi := 0;
   END IF;
   
   IF to_date(ksaika,'DD.MM.YYYY')>to_date(kkaika,'DD.MM.YYYY') THEN
      raise_application_error(-20103,'Syntynyt kuolemansa jlkeen! (Zombie?)');
   END IF;
   
   IF tallikoodi>=0 AND (knappi='Lis' OR knappi='Pivit') THEN
      IF to_date(tallialku,'DD.MM.YYYY')<to_date(ksaika,'DD.MM.YYYY') THEN
	 raise_application_error(-20100,'Ajanut ennen syntymns!');
      END IF;
      IF to_date(tallialku,'DD.MM.YYYY')>to_date(kkaika,'DD.MM.YYYY') THEN
	 raise_application_error(-20101,'Ajanut kuolemansa jlkeen!');
      END IF;
      IF to_date(tallialku,'DD.MM.YYYY')>to_date(talliloppu,'DD.MM.YYYY') THEN
	 raise_application_error(-20102,'Lopetti ennenkuin aloittikaan!');
      END IF;
      
      
      SELECT tyyppi INTO aputyyppi FROM aikasuhteet 
	WHERE ensimmainen='kuljettaja' AND toinen='talli';
      INSERT INTO aika VALUES (to_date(tallialku,'DD.MM.YYYY'),
	to_date(talliloppu,'DD.MM.YYYY'),uusikoodi,tallikoodi,aputyyppi,
	anna_uusi_aikak);
      
   END IF;
   
   
   
   IF knappi = 'Pivit' THEN
      UPDATE kuljettaja
	SET enimi=kenimi,snimi=ksnimi,
	spaikka=kspaikka,saika=to_date(ksaika,'DD.MM.YYYY'),
	kpaikka=kkpaikka,kaika=to_date(kkaika,'DD.MM.YYYY'),
	kansalaisuus=kkansalaisuus, kotipaikka=kkotipaikka,
	kuvaurl=kkuva
	WHERE kuljettaja.koodi=kkoodi;
      
      commit;
      
      otsikko('Kuljettajatiedot pivitetty!',true);
      htp.p('Kuljettajan uudet koskevat tiedot on viety tietokantaan. Nyt voit ');
      htp.anchor('ops$kpalin.kuljmuokk','palata');
      htp.p(' ksittelemn muita kuljettajia.');
   ELSIF knappi = 'Poista' THEN 
      
      otsikko('Poista kuljettaja?',true);
      htp.p('Haluatko todella poistaa tmn kuljettajan ('||kenimi||' '||
	ksnimi||') tietokannasta?');
      htp.p('Poisto on lopullinen eik onnistu, jos kuljettajaan viitataan  ');
      htp.p('muualta jrjestelmst. Paina kyll jos ');
      htp.em('haluat');
      htp.p('poistaa kuljettajan.');
      htp.para;
      htp.formopen('ops$kpalin.kuljpoista');
      htp.formhidden('kkoodi',kkoodi);
      
      htp.tableopen;
      htp.tablerowopen;
      htp.p('<td colspan=50>');

      htp.formsubmit('nappula','Kyll');
      htp.p('<td colspan=50>');
      htp.formreset('Ei','onClick=javascript:history.go(-1)');
      htp.tablerowclose;
      htp.tableclose;
      htp.formclose;
     rollback TO kuljaseta_transa; --peruutetaan muutokset

   ELSIF knappi = 'Lis' THEN

      INSERT INTO kuljettaja VALUES (uusikoodi, kenimi,ksnimi,
	to_date(ksaika,'DD.MM.YYYY'),kspaikka,to_date(kkaika,'DD.MM.YYYY'),
	kkpaikka,kkansalaisuus,kkotipaikka, kkuva);
      
      commit;
      
      otsikko('Kuljettaja listty!');
      htp.p('Uusi kuljettaja on nyt listty tietokantaan ja voit ');
      htp.anchor('ops$kpalin.kuljmuokk','palata');
      htp.p(' muokkaamaan muita kuljettajia.');
   ELSE
      htp.p('Virhe kuljaseta-proseduurissa. Ole hyv ja ota yhteytt ');
      htp.mailto('kimmo.palin@helsinki.fi','yllpitoon.');
   END IF;
     

   paate ;

EXCEPTION
   WHEN OTHERS THEN
     
     rollback TO kuljaseta_transa; --peruutetaan muutokset
     
     IF sqlcode = -20100 THEN
	otsikko('Virheellinen tallikiinnitys!');
	htp.p(kenimi||' '||ksnimi||' ei ole voinut ajaa kilpaa ');
	htp.p(tallialku||' koska hn on syntynyt vasta '||ksaika);
     ELSIF sqlcode = -20101 THEN
	otsikko('Virheellinen tallikiinnitys!');
	htp.p(kenimi||' '||ksnimi||' ei ole voinut ajaa kilpaa '); 
	htp.p(tallialku||' koska hn kuoli jo '||kkaika);
     ELSIF sqlcode = -20102 THEN
	otsikko('Virheellinen tallikiinnitys!');
	htp.p(kenimi||' '||ksnimi||' ei ole voinut lhte tallista '); 
	htp.p(talliloppu||' koska hn aloitti vasta '||tallialku);
     ELSIF sqlcode = -20103 THEN
	otsikko('Virheellinen syntym- tai kuolinaika!');
	htp.p(kenimi||' '||ksnimi||' ei ole voinut synty '||ksaika); 
	htp.p(' jos hn kuoli '||kkaika||'.');

     ELSIF sqlcode = -1847 THEN
	otsikko('Virheellinen pivmr!');
	htp.p('Jokin antamasi pivmr oli vrn muotoinen. Pivmrt ');
	htp.p(' pit antaa muodossa '||to_char(sysdate,'DD.MM.YYYY')||'.');
     ELSIF sqlcode = -1858 THEN
	otsikko('Teksti numerokentss!');
	htp.p('Jossain kentss, johon pit kirjoittaa luku, on muita kuin');
	htp.p(' numeroja.');
     ELSE 
	htp.p('<h3>Proseduuri kuljaseta suoritus pttyi virheeseen:</h3>');
	htp.p('<font color=red>'|| sqlerrm || '</font>');
     END IF;
     
     htp.para;
     htp.p('Muutoksia ei ole talletettu tietokantaan!');
     paate;
END;
/
show errors
  GRANT execute ON kuljaseta TO www_user;
EXIT
  
