CREATE OR replace PROCEDURE kuljettajat
IS
   -- Senna ei ole ajanut kilpailua. Oma syyns.
    cursor kuskit IS SELECT koodi,enimi,snimi,saika,kansalaisuus,
      sum(pisteet) yhtp
      FROM kuljettaja ,tulos 
      WHERE koodi=kuljettaja
      GROUP BY enimi,snimi,saika,kansalaisuus,koodi
      ORDER BY sum(pisteet) DESC;
   
   -- Jnn kysely: Kilpailemattomat kuskit tuovat ongelmia.
--    cursor kuskit IS select koodi,enimi,snimi,saika,kansalaisuus,max(yhtp) yhtp 
--      from ( (select koodi,enimi,snimi,saika,kansalaisuus,sum(pisteet) yhtp 
--      from kuljettaja, tulos 
--      where koodi=kuljettaja 
--      group by enimi,snimi,saika,kansalaisuus,koodi) 
--      union  -- Annetaan jokaiselle kuskille vhintn 0 pistett 
--      (select koodi,enimi,snimi,saika,kansalaisuus,0 AS yhtp from kuljettaja) )
--      group by koodi,enimi,snimi,saika,kansalaisuus;    
   
   kuski kuskit%ROWTYPE;
   counter INTEGER;
   TYPE taustavari IS TABLE OF VARCHAR2(20) INDEX BY binary_integer;
   taustat taustavari;
   tsarja INTEGER;
BEGIN
   -- Hieno kysely menossa olevan sarjan valinnaksi.
   BEGIN 
      SELECT k.sarja INTO tsarja FROM kilpailu k 
	WHERE ABS(sysdate-k.kilpailu)= (SELECT min(ABS(sysdate-a.kilpailu)) FROM
	kilpailu a );
   EXCEPTION
      WHEN no_data_found THEN
	tsarja:=NULL;
   END;

   taustat(2):='bgcolor=#99cccc';
   taustat(1):=NULL;
   otsikko('Formula-1 kuljettajat kautta aikain');
   
   htp.tableopen(NULL,NULL,NULL,NULL,'width=90% border=4');
   htp.tabledata('<a href=ops$kpalin.kalenteri?skoodi='||tsarja||'>Kalenteri</a>','center');
   htp.tabledata('<a href=ops$kpalin.sarjasivu?skoodi='||tsarja||'>Sarja</a>','center');
   htp.tabledata('<a href=ops$kpalin.tallit>Tallit</a>','center');
   htp.tabledata('<a href=ops$kpalin.uutiset>Uutiset</a>','center');
   htp.tableclose;
   htp.line;
   
   htp.p('Seuraavat henkilt ovat joskus ajaneet Formula-1 kilpailun.');
   htp.tableopen(NULL,'center',NULL,NULL,'width=75%');
   
   htp.tableheader('Nimi');
   htp.tableheader('Pisteit');
   htp.tableheader('Syntynyt');
   htp.tableheader('Kansallisuus');
   
   counter:=1;
   FOR kuski IN kuskit LOOP
      htp.tablerowopen;
      htp.tabledata('<a href=ops$kpalin.kuljettajasivu?kkoodi='||kuski.koodi||
	'>'||kuski.enimi||' '||kuski.snimi||'</a>',NULL,NULL,NULL,NULL,NULL,taustat(MOD(counter,2)+1));
      htp.tabledata(kuski.yhtp,NULL,NULL,NULL,NULL,NULL,taustat(MOD(counter,2)+1));
      htp.tabledata(to_char(kuski.saika,'DD.MM.YYYY'),NULL,NULL,NULL,NULL,NULL,taustat(MOD(counter,2)+1));
      htp.tabledata(kuski.kansalaisuus,NULL,NULL,NULL,NULL,NULL,taustat(MOD(counter,2)+1));
      htp.tablerowclose;
      
      counter:=counter+1;
   END LOOP;
   
   htp.tableclose;
   paate;
EXCEPTION
   WHEN OTHERS THEN
     htp.p('<h3>Proseduuri kuljettajat suoritus pttyi virheeseen:</h3>');
     htp.p('<font color=red>'|| sqlerrm || '</font>');
END;
/
show errors
  GRANT execute ON kuljettajat TO www_user;
EXIT
