CREATE OR replace PROCEDURE kuljsyott(kkoodi IN INTEGER DEFAULT NULL ) IS
   cursor tsuhteet IS SELECT talli.koodi,talli.nimi,alkamisaika,
     loppumisaika,kerta
     FROM kuljettaja,talli,aika,aikasuhteet aikas 
     WHERE aikas.toinen='talli' AND aikas.ensimmainen='kuljettaja' AND 
     aika.tyyppi=aikas.tyyppi AND tokakoodi=talli.koodi AND 
     ekakoodi=kuljettaja.koodi  AND ekakoodi=kkoodi;
   tsuhde tsuhteet%ROWTYPE;
   ktieto kuljettaja%ROWTYPE;
BEGIN
   IF NOT autentikoi THEN 
      RETURN  ;
   END IF; 
   otsikko('Kuljettajan muokkaus',true);
   
   iht2.js_checksonly;
   IF kkoodi >= 0 THEN
      SELECT * INTO ktieto FROM kuljettaja WHERE koodi=kkoodi;
   END IF;
   
   IF length(ktieto.kuvaurl) >0 THEN
      htp.p('<img src='||ktieto.kuvaurl||' alt=kuva:'||ktieto.kuvaurl||'>');
   END IF;
   
   htp.formopen('ops$kpalin.kuljaseta');
   
   IF kkoodi >= 0 THEN
      htp.formhidden('kkoodi',ktieto.koodi);
   ELSE
      htp.formhidden('kkoodi',-1);
   END IF;
   
   htp.tableopen;
   htp.tablerowopen;
   htp.tableheader(NULL,NULL,NULL,NULL,50);
   htp.tableheader(NULL,NULL,NULL,NULL,50);
   htp.tablerowclose;
   
   htp.tablerowopen;
   htp.tabledata('Sukunimi:');
   htp.p('<td>');
   htp.formtext('ksnimi',64,128,ktieto.snimi);
   htp.tablerowclose;
   
   htp.tablerowopen;
   htp.tabledata('Etunimet:');
   htp.p('<td>');
   htp.formtext('kenimi',64,128,ktieto.enimi);
   htp.tablerowclose;
   
   htp.tablerowopen;
   htp.tabledata('Syntymaika: ('||to_char(sysdate,'DD.MM.YYYY')||')');
   htp.p('<td>');
   htp.formtext('ksaika',13,13,to_char(ktieto.saika,'DD.MM.YYYY'),
     'onBlur="datecheck(this)"');
   htp.tablerowclose;
   
   htp.tablerowopen;
   htp.tabledata('Syntympaikka:');
   htp.p('<td>');
   htp.formtext('kspaikka',64,128,ktieto.spaikka);
   htp.tablerowclose;
   
   htp.tablerowopen;
   htp.tabledata('Kansalaisuus:');
   htp.p('<td>');
   htp.formtext('kkansalaisuus',32,128,ktieto.kansalaisuus);
   htp.tablerowclose;

   htp.tablerowopen;
   htp.tabledata('Kotipaikka:');
   htp.p('<td>');
   htp.formtext('kkotipaikka',64,128,ktieto.kotipaikka);
   htp.tablerowclose;
   
   htp.tablerowopen;
   htp.tabledata('Kuolinaika: ('||to_char(sysdate,'DD.MM.YYYY')||')');
   htp.p('<td>');
   htp.formtext('kkaika',13,13,to_char(ktieto.kaika,'DD.MM.YYYY'),
     'onBlur="datecheck(this)"');
   htp.tablerowclose;
   htp.tablerowopen;
   htp.tabledata('Kuolinpaikka:');
   htp.p('<td>');
   htp.formtext('kkpaikka',64,128,ktieto.kpaikka);
   htp.tablerowclose;
   
   htp.tablerowopen;
   htp.tabledata('Kuljettajan kuva (URL):');
   htp.p('<td>');
   htp.formtext('kkuva',80,256,ktieto.kuvaurl);
   htp.tablerowclose;
   
   htp.tableclose;
   
   
   -------------------- Tysuhteet --------------------
   
   htp.line;
   htp.p('Tysuhteet tallien kanssa:');
   htp.para;
   
   htp.ulistopen;
   
   FOR tsuhde IN tsuhteet LOOP
      htp.listitem('<a href=ops$kpalin.tallisuhdevalinta?aikakoodi='||
	tsuhde.kerta||'>'||tsuhde.nimi||'</a>'||' ('||
	to_char(tsuhde.alkamisaika,'DD.MM.YYYY')||'-'||
	to_char(tsuhde.loppumisaika,'DD.MM.YYYY')||')');
   END LOOP;
   
   htp.ulistclose;
   
   htp.tableopen(NULL,'center');
   htp.tableheader('Talli');
   htp.tableheader('Lhtien');
   htp.tableheader('Asti');
   
   htp.tablerowopen;
   htp.p('<td>');
   talliselect('tallikoodi','Uusi tysuhde');
   htp.p('</td><td>');
   htp.formtext('tallialku',13,13,NULL,
     'onBlur="datecheck(this)"');
   htp.p('</td><td>');
   htp.formtext('talliloppu',13,13,NULL,
     'onBlur="datecheck(this)"');
   htp.p('</td>');
   htp.tablerowclose;
   htp.tableclose;
   
   
   
   htp.tableopen(NULL,'center');
   htp.tablerowopen;
   htp.p('<td colspan=50 >');
   IF kkoodi >= 0 THEN
      htp.formsubmit('knappi','Pivit');
      htp.p('<td colspan=50>');
      htp.formsubmit('knappi','Poista');
   ELSE
      htp.formsubmit('knappi','Lis');
   END IF;
   
   htp.p('<td colspan=50>');
   htp.formreset('Peruuta', 'onClick=javascript:history.go(-1)');
   htp.tablerowclose;
   htp.tableclose;
   htp.formclose;

   
   paate ;

EXCEPTION
   WHEN OTHERS THEN
     htp.p('<h3>Proseduuri kuljsyott suoritus pttyi virheeseen:</h3>');
     htp.p('<font color=red>'|| sqlerrm || '</font>');
END;
/
show errors
  GRANT execute ON kuljsyott TO www_user;
EXIT
  
