CREATE OR replace PROCEDURE sarjaaseta(skoodi IN INTEGER,
				       stunnus IN VARCHAR2,
				       snappi IN VARCHAR2,
				       stallit IN owa_util.ident_arr,
				       krata IN VARCHAR2 DEFAULT -1,
				       kaaaika IN VARCHAR2 DEFAULT NULL ,
				       kaika IN VARCHAR2 DEFAULT NULL )
IS
   cursor kilpailut IS SELECT * FROM kilpailu WHERE sarja=skoodi;
   apu_cnt INTEGER;
   sarja_koodi INTEGER;
   tkisa kilpailut%ROWTYPE;
BEGIN
   IF NOT autentikoi THEN 
      RETURN  ;
   END IF; 
      
   savepoint sarjaaseta_transa;
   
   IF snappi='Lis' THEN 
	 SELECT max(koodi)+1 INTO sarja_koodi FROM sarja;
	 
	 IF sarja_koodi IS NULL THEN
	    sarja_koodi := 0;
	 END IF;
	 
	 INSERT INTO sarja VALUES(sarja_koodi,stunnus);
      
   ELSIF snappi='Pivit' THEN
      sarja_koodi:=skoodi;
      
      UPDATE sarja SET vuosi=stunnus WHERE koodi=skoodi;
      
      apu_cnt:=2;
      DELETE tallisarja WHERE sarjakoodi=skoodi;
      BEGIN 
	 LOOP
	    INSERT INTO tallisarja VALUES (to_number(stallit(apu_cnt)),skoodi);
	    apu_cnt:=apu_cnt+1;
	 END LOOP;
      EXCEPTION
	 WHEN no_data_found THEN
	   apu_cnt:=apu_cnt;  
      END;
   END IF;
   
      
   IF krata != -1 AND (snappi = 'Pivit' OR snappi = 'Lis') THEN    
      
      SELECT max(koodi)+1 INTO apu_cnt FROM kilpailu;
	 
      IF apu_cnt IS NULL THEN
	 apu_cnt:=0;
      END IF;
	 
      INSERT INTO kilpailu VALUES(apu_cnt,krata,
	to_date(kaaaika,'DD.MM.YYYY'),
	to_date(kaika,'DD.MM.YYYY'),sarja_koodi);
	    
   END IF;
   
   IF snappi = 'Poista' THEN
      otsikko('Poista sarja '||stunnus,true);
      htp.p('Haluatko todella poistaa koko sarjan ja kaikki siin ajetut ');
      htp.p('ja ajamattomat kilpailut tuloksineen? Paina kyll jos ');
      htp.em('haluat');
      htp.p(' poistaa sarjan.');
      htp.para;
      htp.formopen('ops$kpalin.sarjapoista');
      htp.formhidden('skoodi',skoodi);
      
      htp.tableopen;
      htp.tablerowopen;
      htp.p('<td colspan=50>');


      htp.formsubmit('nappula','Kyll');
      htp.p('<td colspan=50>');
      htp.formreset('Ei','onClick=javascript:history.go(-1)');
      htp.tablerowclose;
      htp.tableclose;
      htp.formclose;

      paate;
   END IF;
   
   
   commit;
   
   IF snappi != 'Poista' AND sarja_koodi>=0 THEN 
      sarjasyott(sarja_koodi);
   END IF;
   
   --htp.p('<html onLoad=ops$kpalin.sarjasyott?tkausi='||sarja_koodi||'>');

EXCEPTION
   WHEN OTHERS THEN
     rollback TO sarjaaseta_transa ;
     IF sqlcode = -1847 THEN
	otsikko('Virheellinen pivmr!');
	htp.p('Jokin antamasi pivmr oli vrn muotoinen. Pivmrt ');
	htp.p(' pit antaa muodossa '||to_char(sysdate,'DD.MM.YYYY')||'.');
     ELSIF sqlcode = -1858 THEN
	otsikko('Teksti numerokentss!');
	htp.p('Jossain kentss, johon pit kirjoittaa luku, on muita kuin');
	htp.p(' numeroja.');
     ELSE
	htp.p('<h3>Proseduuri sarjaaseta suoritus pttyi virheeseen:</h3>');
	htp.p('<font color=red>'|| sqlerrm || '</font>');
     END IF;
     
     htp.para;
     htp.p('Muutoksia ei ole talletettu!');
END;
/
show errors
  GRANT execute ON sarjaaseta TO www_user;
EXIT
  













