CREATE OR replace PROCEDURE sarjapoista ( skoodi IN INTEGER,
					  nappula IN VARCHAR2 DEFAULT NULL ) IS
   cursor kilpailut IS SELECT * FROM kilpailu WHERE sarja=skoodi;
   poistot sarja%ROWTYPE;
   kisa kilpailut%ROWTYPE;
BEGIN
   IF NOT autentikoi THEN 
      RETURN  ;
   END IF; 
   
   SELECT * INTO poistot FROM sarja WHERE koodi=skoodi;
   
   savepoint sarjapois_transa;
   
   FOR kisa IN kilpailut LOOP
      DELETE tulos WHERE kilpailu=kisa.koodi;
      DELETE tapaus WHERE kilpailu=kisa.koodi;
   END LOOP;
   DELETE kilpailu WHERE sarja=skoodi;
   DELETE tallisarja WHERE sarjakoodi=skoodi;
   DELETE sarja WHERE koodi=skoodi;
   
   commit;
   
   otsikko('Sarja poistettu',true);
   htp.p(poistot.vuosi||'-sarja ja kaikki siihen liittyvt tiedot on poistettu. Voit palata takaisin ');
   htp.anchor('ops$kpalin.paasivu','psivulle.');
   paate ;

EXCEPTION
   WHEN OTHERS THEN
     htp.p('<h3>Proseduuri sarjapoista suoritus pttyi virheeseen:</h3>');
     htp.p('<font color=red>'|| sqlerrm || '</font>');
END;
/
show errors
  GRANT execute ON sarjapoista TO www_user;
EXIT
  
