CREATE OR replace PROCEDURE sarjasivu(skoodi IN INTEGER)
IS
   cursor hksarja IS SELECT k.koodi,k.enimi,k.snimi,talli.nimi tnimi,
     sum(pisteet) yhtp, talli.koodi tkoodi
     FROM kuljettaja k,talli,tallisarja,kilpailu kplu,aika,tulos
     WHERE  
     tulos.kuljettaja=k.koodi AND
     tulos.kilpailu=kplu.koodi AND
     tallisarja.sarjakoodi=kplu.sarja AND 
     tallisarja.tallikoodi=talli.koodi AND 
     aika.tyyppi=(SELECT tyyppi FROM aikasuhteet 
     WHERE ensimmainen='kuljettaja' AND toinen='talli') AND
     aika.alkamisaika<kplu.aajo AND 
     (aika.loppumisaika IS NULL OR aika.loppumisaika>kplu.kilpailu)
     AND aika.ekakoodi=k.koodi AND 
     aika.tokakoodi=talli.koodi AND kplu.sarja=skoodi
     GROUP BY k.koodi,k.enimi,k.snimi,talli.nimi,talli.koodi
     ORDER BY sum(pisteet) DESC ;
   
   cursor valmistajasarja IS SELECT talli.koodi,talli.nimi tnimi,
     sum(pisteet) yhtp
     FROM kuljettaja k,talli,tallisarja,kilpailu kplu,aika,tulos
     WHERE  
     tulos.kuljettaja=k.koodi AND
     tulos.kilpailu=kplu.koodi AND
     tallisarja.sarjakoodi=kplu.sarja AND 
     tallisarja.tallikoodi=talli.koodi AND 
     aika.tyyppi=(SELECT tyyppi FROM aikasuhteet 
     WHERE ensimmainen='kuljettaja' AND toinen='talli') AND
     aika.alkamisaika<kplu.aajo AND 
     (aika.loppumisaika IS NULL OR aika.loppumisaika>kplu.kilpailu)
     AND aika.ekakoodi=k.koodi AND 
     aika.tokakoodi=talli.koodi AND kplu.sarja=skoodi
     GROUP BY talli.koodi,talli.nimi
     ORDER BY sum(pisteet) DESC ;

   itsekas hksarja%ROWTYPE;
   porukka valmistajasarja%ROWTYPE;
   counter INTEGER;
   TYPE taustavari IS TABLE OF VARCHAR2(20) INDEX BY binary_integer;
   taustat taustavari;
BEGIN
   otsikko('Sarjatilanne');
   taustat(2):='bgcolor=#99cccc';
   taustat(1):=NULL;
   
   htp.tableopen(NULL,NULL,NULL,NULL,'width=90% border=4');
   htp.tabledata('<a href=ops$kpalin.kalenteri?skoodi='||skoodi||'>Kalenteri</a>','center');
   htp.tabledata('<a href=ops$kpalin.uutiset>Uutiset</a>','center');
   htp.tabledata('<a href=ops$kpalin.tallit>Tallit</a>','center');
   htp.tabledata('<a href=ops$kpalin.kuljettajat>Kuljettajat</a>','center');
   htp.tableclose;
   htp.para;
   
   htp.tableopen(NULL,'center',NULL,NULL,'width=80%');
   htp.tablerowopen;
   htp.tableheader('Tilanne kuljettajien MM-sarjassa');
   htp.tableheader('Tilanne valmistajien mestaruussarjassa');
   htp.tablerowclose;
   htp.tablerowopen;
   htp.p('<td>');
   
   htp.tableopen(NULL,'center');
   counter:=1;
   FOR itsekas IN hksarja LOOP
      htp.tablerowopen;
      htp.tabledata(counter,'right',NULL,NULL,NULL,NULL,taustat(MOD(counter,2)+1));
      htp.tabledata('<a href=ops$kpalin.kuljettajasivu?kkoodi='||itsekas.koodi||'>'||itsekas.enimi||' '||itsekas.snimi||'</a> (<a href=ops$kpalin.tallisivu?tkoodi='||itsekas.tkoodi||'>'||itsekas.tnimi||'</a>)',NULL,NULL,NULL,NULL,NULL,taustat(MOD(counter,2)+1));
      htp.tabledata(itsekas.yhtp||' p','right',NULL,NULL,NULL,NULL,taustat(MOD(counter,2)+1));
      htp.tablerowclose;
      counter:=counter+1;
   END LOOP;
   htp.tableclose;
   
   htp.p('</td><td valign=top>');
   
   
   htp.tableopen(NULL,'center');
   counter:=1;
   FOR porukka IN valmistajasarja LOOP
      htp.tablerowopen;
      htp.tabledata(counter,'right',NULL,NULL,NULL,NULL,taustat(MOD(counter,2)+1));
      htp.tabledata('<a href=ops$kpalin.tallisivu?tkoodi='||porukka.koodi||'>'||porukka.tnimi||'</a>',NULL,NULL,NULL,NULL,NULL,taustat(MOD(counter,2)+1));
      htp.tabledata(porukka.yhtp||' p','right',NULL,NULL,NULL,NULL,taustat(MOD(counter,2)+1));
      htp.tablerowclose;
      counter:=counter+1;
   END LOOP;
   htp.tableclose;
   htp.p('</td>');
   htp.tableclose;
   
   paate;
EXCEPTION
   WHEN OTHERS THEN
     htp.p('<h3>Proseduuri sarjasivu suoritus pttyi virheeseen:</h3>');
     htp.p('<font color=red>'|| sqlerrm || '</font>');
END;
/
show errors
  GRANT execute ON sarjasivu TO www_user;
EXIT
