CREATE OR replace PROCEDURE sarjasyott(tkausi IN INTEGER)  IS
   cursor kaikkitallit IS SELECT * FROM talli;
   cursor kilpailut IS SELECT kilpailu.koodi, rata.nimi,
     kilpailu.aajo,kilpailu.kilpailu
     FROM kilpailu,rata 
     WHERE rata.koodi=kilpailu.rata AND sarja=tkausi
     ORDER BY kilpailu;
   tamas sarja%ROWTYPE;
   ttalli kaikkitallit%ROWTYPE;
   tkisa kilpailut%ROWTYPE;
   turha INTEGER;
BEGIN
   IF NOT autentikoi THEN 
      RETURN  ;
   END IF; 
   
   iht2.js_checksonly;
   IF tkausi >=0 THEN
      SELECT * INTO tamas FROM sarja WHERE koodi=tkausi;
   END IF;
   
   IF tamas.vuosi IS NULL THEN
      tamas.vuosi := to_char(sysdate,'YYYY');
   END IF;
   
   otsikko('Sarjatiedot',true);
   
   htp.formopen('ops$kpalin.sarjaaseta');
   
   htp.formhidden('stallit','I-Like-Jello!');
   
   htp.formhidden('skoodi',tkausi);
   htp.tableopen;
   htp.tablerowopen;
   htp.tabledata('Sarjan tunnus:');
   htp.p('<td>');
   htp.formtext('stunnus',10,64,tamas.vuosi);
   htp.tablerowclose;
   htp.tablerowopen;
   htp.tabledata('Sarjaan osallistuvat tallit:');
   htp.p('<td></td>');
   htp.tablerowclose;
   
   
   FOR ttalli IN kaikkitallit LOOP
      htp.tablerowopen;
      htp.p('<td> </td><td>');
      BEGIN 
	 SELECT tallikoodi INTO turha FROM tallisarja WHERE sarjakoodi=tkausi 
	   AND tallikoodi=ttalli.koodi;
      EXCEPTION
	 WHEN no_data_found THEN
	   turha:=NULL;
      END;
	
      IF turha IS NOT NULL THEN
	 htp.formcheckbox('stallit',ttalli.koodi,'CHECKED');
      ELSE
	 htp.formcheckbox('stallit',ttalli.koodi);
      END IF;
      
      htp.p(ttalli.nimi||'</td>');
      htp.tablerowclose;
   END LOOP;
   
   htp.tableclose;
   htp.line;
   htp.p('Sarjassa ajettavat kilpailut:');
   htp.br;
   
   htp.ulistopen;
   FOR tkisa IN kilpailut LOOP
      htp.listitem('<a href=ops$kpalin.kilpailuvalinta?kkoodi='||
	tkisa.koodi||'>'||
	tkisa.nimi||' '||to_char(tkisa.aajo,'DD.MM.YYYY')||'-'||
	to_char(tkisa.kilpailu,'DD.MM.YYYY')||'</a>');
   END LOOP;
   htp.ulistclose;
   
   htp.tableopen(NULL,'center');
   htp.tableheader('Rata');
   htp.tableheader('Aika-ajot');
   htp.tableheader('Kilpailu');
   
   htp.tablerowopen;
   htp.p('<td>');
   rataselect('krata','Uusi kilpailu');
   htp.p('</td><td>');
   htp.formtext('kaaaika',13,13,NULL,'onBlur="datecheck(this)"');
   htp.p('</td><td>');
   htp.formtext('kaika',13,13,NULL,'onBlur="datecheck(this)"');
   htp.tablerowclose;
   htp.tableclose;
   
   
   htp.tableopen(NULL,'center');
   htp.tablerowopen;
   htp.p('<td colspan=50 >');
   IF tkausi >= 0 THEN
      htp.formsubmit('snappi','Pivit');
      htp.p('<td colspan=50>');
      htp.formsubmit('snappi','Poista');
   ELSE
      htp.formsubmit('snappi','Lis');
   END IF;
   
   htp.p('<td colspan=50>');
   htp.formreset('Peruuta','onClick=javascript:parent.location=''ops$kpalin.valitsekaudet?valitse=joku'||'&'||'tkausi='||tkausi||'''');
   htp.tablerowclose;
   htp.tableclose;
   
   
   htp.formclose;
   paate ;

EXCEPTION
   WHEN OTHERS THEN
     htp.p('<h3>Proseduuri sarjasyott suoritus pttyi virheeseen:</h3>');
     htp.p('<font color=red>'|| sqlerrm || '</font>');
END;
/
show errors
  GRANT execute ON sarjasyott TO www_user;
EXIT
  
