CREATE OR replace PROCEDURE talliaseta 
  (tkoodi IN INTEGER,
   tnappi IN VARCHAR2,
   tnimi IN VARCHAR2,
   tkotipaikka IN VARCHAR2 DEFAULT NULL,
   tpaallikko IN VARCHAR2 DEFAULT NULL,
   tpervuosi IN VARCHAR2 DEFAULT NULL,
   tliikev IN INTEGER DEFAULT NULL,
   ---------- kotiradat ----------
   rkoodi IN VARCHAR2  DEFAULT NULL,
   ralku IN VARCHAR2  DEFAULT NULL,
   rloppu IN VARCHAR2  DEFAULT NULL,
   ---------- Kytetyt renkaat ----------
   rengaskoodi IN VARCHAR2  DEFAULT NULL,
   rengasalku IN VARCHAR2 DEFAULT NULL,
   rengasloppu IN VARCHAR2 DEFAULT NULL,
  ---------- Moottorit ----------
  mkoodi IN INTEGER DEFAULT NULL,
  malku IN VARCHAR2 DEFAULT NULL,
  mloppu IN VARCHAR2 DEFAULT NULL)
IS
   uusikoodi INTEGER := tkoodi;
   aputyyppi INTEGER;
   uusiaikakoodi INTEGER;
BEGIN
   IF NOT autentikoi THEN 
      RETURN  ;
   END IF; 
   
   savepoint talliaseta_transa;
   
      
   IF uusikoodi IS NULL OR uusikoodi<0 THEN
      SELECT max(talli.koodi)+1 INTO uusikoodi FROM talli;
   END IF;
   IF uusikoodi IS NULL THEN 
      uusikoodi := 0;
   END IF;
   
   
   IF tnappi='Lis' OR tnappi='Pivit' THEN
      uusiaikakoodi := anna_uusi_aikak;
      IF rkoodi>=0 THEN
	 SELECT tyyppi INTO aputyyppi FROM aikasuhteet 
	   WHERE ensimmainen='rata' AND toinen='talli';
	 INSERT INTO aika VALUES (to_date(ralku,'DD.MM.YYYY'),
	   to_date(rloppu,'DD.MM.YYYY'),rkoodi,uusikoodi,aputyyppi,
				 anna_uusi_aikak);
      END IF;
      IF mkoodi>=0 THEN
	 SELECT tyyppi INTO aputyyppi FROM aikasuhteet 
	   WHERE ensimmainen='moottori' AND toinen='talli';
	 INSERT INTO aika VALUES (to_date(malku,'DD.MM.YYYY'),
	   to_date(mloppu,'DD.MM.YYYY'),mkoodi,uusikoodi,aputyyppi,
				 anna_uusi_aikak);
      END IF;
      IF rengaskoodi>=0 THEN
	 SELECT tyyppi INTO aputyyppi FROM aikasuhteet 
	   WHERE ensimmainen='renkaat' AND toinen='talli';
	 INSERT INTO aika VALUES (to_date(rengasalku,'DD.MM.YYYY'),
	   to_date(rengasloppu,'DD.MM.YYYY'),rengaskoodi,uusikoodi,
	   aputyyppi,anna_uusi_aikak);
      END IF;
   END IF;
      
         
      
   IF tnappi = 'Pivit' THEN
      --htp.p(mkoodi||':'||tkoodi||':'||rkoodi);
      UPDATE talli
	SET nimi = tnimi, kotipaikka=tkotipaikka, 
	perustettu=to_date(tpervuosi,'YYYY'), 
	paallikko=tpaallikko, liikevaihto=tliikev
	WHERE talli.koodi=tkoodi;
      otsikko('Tallitiedot pivitetty!',true);
      htp.p('Uudet tallia koskevat tiedot on viety tietokantaan. Nyt voit ');
      htp.anchor('ops$kpalin.tallimuokk','palata');
      htp.p(' ksittelemn muita talleja tai jatkaa ');
      htp.anchor('ops$kpalin.tallisyott?tkoodi='||tkoodi,'nykyisen');
      htp.p(' tallin ksittely.');
   ELSIF tnappi = 'Poista' THEN 
      otsikko('Poista talli?',true);
      htp.p('Haluatko todella poistaa '|| tnimi||' radan tietokannasta?');
      htp.p('Poisto on lopullinen eik onnistu, jos talliin on viitteit ');
      htp.p('muualta jrjestelmst. Paina kyll jos ');
      htp.em('haluat');
      htp.p('poistaa tallin.');
      htp.para;
      htp.formopen('ops$kpalin.tallipoista');
      htp.formhidden('tkoodi',tkoodi);
      
      htp.tableopen;
      htp.tablerowopen;
      htp.p('<td colspan=50>');


      htp.formsubmit('nappula','Kyll');
      htp.p('<td colspan=50>');
      htp.formreset('Ei','onClick=javascript:history.go(-1)');
      htp.tablerowclose;
      htp.tableclose;
      htp.formclose;

   ELSIF tnappi = 'Lis' THEN

     
      INSERT INTO talli VALUES (uusikoodi, tnimi,tkotipaikka,
	to_date(tpervuosi,'YYYY'),tpaallikko,tliikev);
      
      otsikko('Talli listty!');
      htp.p('Uusi talli on nyt listty tietokantaan ja voit ');
      htp.anchor('ops$kpalin.tallimuokk','palata');
      htp.p(' muokkaamaan muita talleja.');
   ELSE
      htp.p('Virhe talliaseta-proseduurissa. Ole hyv ja ota yhteytt ');
      htp.mailto('kimmo.palin@helsinki.fi','yllpitoon.');
   END IF;
     
   commit;
   
   paate ;

EXCEPTION
   WHEN OTHERS THEN
     rollback TO talliaseta_transa; --peruutetaan muutokset
     IF sqlcode = -1847 THEN
	otsikko('Virheellinen pivmr!');
	htp.p('Jokin antamasi pivmr oli vrn muotoinen. Pivmrt ');
	htp.p(' pit antaa muodossa '||to_char(sysdate,'DD.MM.YYYY')||'.');
     ELSIF sqlcode = -1858 THEN
	otsikko('Teksti numerokentss!');
	htp.p('Jossain kentss, johon pit kirjoittaa luku, on muita kuin');
	htp.p(' numeroja.');
     ELSE 
	htp.p('<h3>Proseduuri talliaseta suoritus pttyi virheeseen:</h3>');
	htp.p('<font color=red>'|| sqlerrm || '</font>');
     END IF;
     
     htp.p('Muutoksia ei ole talletettu tietokantaan!');
     paate;
END;
/
show errors
  GRANT execute ON talliaseta TO www_user;
EXIT
  


