CREATE OR replace PROCEDURE tallisivu(tkoodi IN INTEGER)
IS
   tama talli%ROWTYPE;
   tsarja INTEGER;
   krata rata%ROWTYPE;
BEGIN
   
   -- Hieno kysely menossa olevan sarjan valinnaksi.
   BEGIN 
      SELECT k.sarja INTO tsarja FROM kilpailu k 
	WHERE ABS(sysdate-k.kilpailu)= (SELECT min(ABS(sysdate-a.kilpailu)) FROM
	kilpailu a );
   EXCEPTION
      WHEN no_data_found THEN
	tsarja:=NULL;
   END;
   
   
   SELECT * INTO tama FROM talli WHERE koodi=tkoodi;
   
   otsikko(tama.nimi||'-talli');
   
   htp.tableopen(NULL,NULL,NULL,NULL,'width=90% border=4');
   htp.tabledata('<a href=ops$kpalin.kalenteri?skoodi='||tsarja||'>Kalenteri</a>','center');
   htp.tabledata('<a href=ops$kpalin.sarjasivu?skoodi='||tsarja||'>Sarja</a>','center');
   htp.tabledata('<a href=ops$kpalin.uutiset>Uutiset</a>','center');
   htp.tabledata('<a href=ops$kpalin.kuljettajat>Kuljettajat</a>','center');
   htp.tableclose;
   htp.line;
   
   htp.tableopen(NULL,NULL,NULL,NULL,'width=75%');
   htp.tablerowopen;
   htp.tabledata('Nimi:');
   htp.tabledata(tama.nimi);
   htp.tablerowclose;
   htp.tablerowopen;
   htp.tabledata('Kotipaikka:');
   htp.tabledata(tama.kotipaikka);
   htp.tablerowclose;
   htp.tablerowopen;
   htp.tabledata('Perustamisvuosi:');
   htp.tabledata(to_char(tama.perustettu,'YYYY'));
   htp.tablerowclose;
   htp.tablerowopen;
   BEGIN 
      SELECT r.koodi,r.nimi,r.sijainti,r.pituus,r.ennatys,r.vvuosi,r.kuvaurl
	INTO krata 
	FROM rata r,aika
	WHERE aika.tyyppi=(SELECT tyyppi FROM aikasuhteet 
	WHERE ensimmainen='rata' AND toinen='talli') AND
	r.koodi=aika.ekakoodi AND aika.tokakoodi=tkoodi
	AND aika.alkamisaika<sysdate AND 
	(aika.loppumisaika>sysdate OR aika.loppumisaika IS NULL);
      htp.tabledata('Kotirata:');
      htp.tabledata('<a href=ops$kpalin.ratasivu?rkoodi='||krata.koodi||'>'||
	krata.nimi||', '||krata.sijainti||'</a>');
      htp.tablerowclose;
      htp.tablerowopen;
   EXCEPTION
      WHEN OTHERS THEN
	krata.nimi:=NULL;
   END;
   htp.tabledata('Tallipllikk:');
   htp.tabledata(tama.paallikko);
   htp.tablerowclose;
   htp.tablerowopen;
   htp.tabledata('Liikevaihto:');
   htp.tabledata(tama.liikevaihto||' USD');
   htp.tablerowclose;
   htp.tableclose;
   
   paate;
EXCEPTION
   WHEN OTHERS THEN
     htp.p('<h3>Proseduuri tallisivu suoritus pttyi virheeseen:</h3>');
     htp.p('<font color=red>'|| sqlerrm || '</font>');
END;
/
show errors
  GRANT execute ON tallisivu TO www_user;
EXIT
