CREATE OR replace PROCEDURE tallisuhdeaseta(aikakoodi IN INTEGER,
					    tnappi IN VARCHAR2,
					    tkoodi IN INTEGER,
					    talku IN VARCHAR2,
					    tloppu IN VARCHAR2 DEFAULT null)
IS
   taika aika%ROWTYPE;
   tkuski kuljettaja%ROWTYPE;
BEGIN
   IF NOT autentikoi THEN 
      RETURN  ;
   END IF;
   
   SELECT * INTO taika FROM aika WHERE kerta=aikakoodi;
   SELECT * INTO tkuski FROM kuljettaja WHERE koodi=taika.ekakoodi;
   
   IF tnappi='Pivit' THEN
      IF to_date(talku,'DD.MM.YYYY')<tkuski.saika THEN
	 raise_application_error(-20100,'Ajanut ennen syntymns!');
      END IF;
      IF to_date(talku,'DD.MM.YYYY')>tkuski.kaika THEN
	 raise_application_error(-20101,talku);
      END IF;
      IF to_date(tloppu,'DD.MM.YYYY')>tkuski.kaika THEN
	 raise_application_error(-20101,tloppu);
      END IF;
      IF to_date(talku,'DD.MM.YYYY')>to_date(tloppu,'DD.MM.YYYY') THEN
	 raise_application_error(-20102,'Lopetti ennenkuin aloittikaan!');
      END IF;
   END IF;
   
   
   IF tnappi = 'Poista' THEN
      DELETE aika WHERE kerta = taika.kerta;
      
      otsikko('Tallikiinnitys poistettu',true);
      htp.p('Merkint tysuhteesta tallin kanssa on nyt poistettu.');
   ELSIF tnappi = 'Pivit' THEN
      UPDATE aika SET tokakoodi=tkoodi, 
	alkamisaika=to_date(talku,'DD.MM.YYYY'),
	loppumisaika=to_date(tloppu,'DD.MM.YYYY')
	WHERE kerta=aikakoodi;
      
      otsikko('Tiedot pivitetty',true);
      htp.p('Tiedot tallikiinnityksest on nyt pivitetty.');
   END IF;
   
   
   htp.p(' Voit palata, joko ');
   htp.anchor('ops$kpalin.kuljmuokk','kuljettajalistaan');
   htp.p('tai ksiteltvn ');
   htp.anchor('ops$kpalin.kuljsyott?kkoodi='||taika.ekakoodi,'kuljettajaan.');
    
   paate ;
   
EXCEPTION
   WHEN OTHERS THEN
     
     IF sqlcode = -20100 THEN
	otsikko('Virheellinen tallikiinnitys!');
	htp.p(tkuski.enimi||' '||tkuski.snimi||' ei ole voinut ajaa kilpaa ');
	htp.p(talku||' koska hn on syntynyt vasta '||
	  to_char(tkuski.saika,'DD.MM.YYYY'));
     ELSIF sqlcode = -20101 THEN
	otsikko('Virheellinen tallikiinnitys!');
	htp.p(tkuski.enimi||' '||tkuski.snimi||' ei ole voinut ajaa kilpaa '); 
	htp.p(sqlerrm||' koska hn kuoli jo '||
	  to_char(tkuski.kaika,'DD.MM.YYYY'));
     ELSIF sqlcode = -20102 THEN
	otsikko('Virheellinen tallikiinnitys!');
	htp.p(tkuski.enimi||' '||tkuski.snimi||' ei ole voinut lhte tallista '); 
	htp.p(tloppu||' koska hn aloitti vasta '||talku);
     ELSIF sqlcode = -1847 THEN
	otsikko('Virheellinen pivmr!');
	htp.p('Jokin antamasi pivmr oli vrn muotoinen. Pivmrt ');
	htp.p(' pit antaa muodossa '||to_char(sysdate,'DD.MM.YYYY')||'.');
     ELSIF sqlcode = -1858 THEN
	otsikko('Teksti numerokentss!');
	htp.p('Jossain kentss, johon pit kirjoittaa luku, on muita kuin');
	htp.p(' numeroja.');
     ELSE 
	htp.p('<h3>Proseduuri kotirataaseta suoritus pttyi virheeseen:</h3>');
	htp.p('<font color=red>'|| sqlerrm || '</font>');
     END IF;
     
     htp.para;
     htp.p('Muutoksia ei ole talletettu tietokantaan!');
     paate;
END;
/
show errors
  GRANT execute ON tallisuhdeaseta TO www_user;
EXIT
  
