CREATE OR replace PROCEDURE tallisyott(tkoodi IN INTEGER DEFAULT null)  IS
   cursor trenkaat IS SELECT renkaat.koodi,alkamisaika,loppumisaika,valmistaja,renkaat.tyyppi,kerta
     FROM renkaat,talli,aika,aikasuhteet aikas WHERE
     aikas.toinen='talli' AND aikas.ensimmainen='renkaat' AND 
     aika.tyyppi=aikas.tyyppi AND tokakoodi=talli.koodi AND 
     ekakoodi=renkaat.koodi AND tokakoodi=tkoodi;
   cursor kradat IS SELECT rata.koodi,rata.nimi,rata.sijainti,alkamisaika,
     loppumisaika,kerta
     FROM rata,talli,aika,aikasuhteet aikas 
     WHERE aikas.toinen='talli' AND aikas.ensimmainen='rata' AND 
     aika.tyyppi=aikas.tyyppi AND tokakoodi=talli.koodi AND 
     ekakoodi=rata.koodi  AND tokakoodi=tkoodi;
   cursor tmoottorit IS SELECT moottori.koodi,moottori.tyyppi AS tyyppi,
     moottori.vuosimalli,moottori.teho,alkamisaika,loppumisaika,
     kerta,valmistaja
     FROM moottori,talli,aika,aikasuhteet aikas 
     WHERE aikas.toinen='talli' AND aikas.ensimmainen='moottori' AND 
     aika.tyyppi=aikas.tyyppi AND tokakoodi=talli.koodi AND 
     ekakoodi=moottori.koodi  AND tokakoodi=tkoodi;
   krata kradat%ROWTYPE ;
   trengas trenkaat%ROWTYPE ;
   tmoottori tmoottorit%ROWTYPE;
   ttieto talli%ROWTYPE;
   
BEGIN
   IF NOT autentikoi THEN 
      RETURN  ;
   END IF; 
   iht2.js_checksonly;
   
   otsikko('Tallitietojen muokkaus',true);
   
   IF tkoodi >= 0 THEN 
      SELECT * INTO ttieto FROM talli WHERE talli.koodi=tkoodi;
   END IF;
   

   htp.formopen('ops$kpalin.talliaseta');
   
   IF tkoodi >= 0 THEN
      htp.formhidden('tkoodi',ttieto.koodi);
   ELSE
      htp.formhidden('tkoodi',-1);
   END IF;
   
   htp.tableopen;
   htp.tablerowopen;
   htp.tabledata('Tallin nimi:');
   htp.p('<td>');
   htp.formtext('tnimi',64,256,ttieto.nimi);

   htp.tablerowclose;
   htp.tablerowopen;
   htp.tabledata('Kotipaikka:');
   htp.p('<td>');
   htp.formtext('tkotipaikka',64,256,ttieto.kotipaikka);
   htp.tablerowclose;
   htp.tableclose;
   htp.line;
   
   htp.tableopen;

   htp.tablerowopen;
   htp.tabledata('Tallipllikk:');
   htp.p('<td>');
   htp.formtext('tpaallikko',64,128,ttieto.paallikko);
   htp.tablerowclose;
   
   htp.tablerowopen;
   htp.tabledata('Perustamisvuosi: ('||to_char(sysdate,'YYYY')||')');
   htp.p('<td>');
   htp.formtext('tpervuosi',10,4,to_char(ttieto.perustettu,'YYYY'),
     'onBlur="numcheck(this)"');
   htp.tablerowclose;
   
   htp.tablerowopen;
   htp.tabledata('Tallin liikevaihto: ');
   htp.p('<td>');
   htp.formtext('tliikev',10,10,ttieto.liikevaihto,'onBlur="numcheck(this)"');
   htp.p(' USD');
   
   htp.tablerowclose;
   htp.tablerowopen;
   htp.tableclose;
   ------------------------------ radat ------------------------------
   htp.line;
   htp.p('Tallin kotiradat:');
   htp.para;
   
   htp.ulistopen;
   
   FOR krata IN kradat LOOP
      htp.listitem('<a href=ops$kpalin.kotiratavalinta?aikakoodi='||
	krata.kerta||'>'||krata.nimi||'</a>'||' ('||
	to_char(krata.alkamisaika,'DD.MM.YYYY')||'-'||
	to_char(krata.loppumisaika,'DD.MM.YYYY')||')');
   END LOOP;
   
   htp.ulistclose;
   
   htp.tableopen(NULL,'center');
   htp.tableheader('Kotirata');
   htp.tableheader('Lhtien');
   htp.tableheader('Asti');
   
   htp.tablerowopen;
   htp.p('<td>');
   rataselect('rkoodi','Uusi kotirata');
   htp.p('</td><td>');
   htp.formtext('ralku',13,13,NULL,'onBlur="datecheck(this)"');
   htp.p('</td><td>');
   htp.formtext('rloppu',13,13,NULL,'onBlur="datecheck(this)"');
   htp.p('</td>');
   htp.tablerowclose;
   htp.tableclose;
   
   --------------------- moottorit ------------------------------
   htp.line;
   htp.p('Tallin kyttmt moottorit:');
   htp.para;
   
   htp.ulistopen;
   
   FOR tmoottori IN tmoottorit LOOP
      htp.listitem('<a href=ops$kpalin.moottorivalinta?aikakoodi='||
	tmoottori.kerta||'>'|| tmoottori.valmistaja ||' '||
	tmoottori.tyyppi||' ('||tmoottori.teho||
	'hv)</a> ('|| to_char(tmoottori.alkamisaika,'DD.MM.YYYY')||'-'||
	to_char(tmoottori.loppumisaika,'DD.MM.YYYY')||')');
   END LOOP;
   
   htp.ulistclose;

   htp.tableopen(NULL,'center');
   htp.tableheader('Mootorit');
   htp.tableheader('Lhtien');
   htp.tableheader('Asti');
   
   htp.tablerowopen;
   htp.p('<td>');
   moottoriselect('mkoodi','Uusi Moottori');
   htp.p('</td><td>');
   htp.formtext('malku',13,13,NULL,'onBlur="datecheck(this)"');
   htp.p('</td><td>');
   htp.formtext('mloppu',13,13,NULL,'onBlur="datecheck(this)"');
   htp.p('</td>');
   htp.tablerowclose;
   htp.tableclose;

   
   --------------------- renkaat------------------------------
   htp.line;
   htp.p('Tallin kyttmt renkaat:');
   htp.para;
   
   htp.ulistopen;
   
   FOR trengas IN trenkaat LOOP
      htp.listitem('<a href=ops$kpalin.rengasvalinta?aikakoodi='||trengas.kerta
	||'>'||trengas.valmistaja||','||
	trengas.tyyppi||'</a> ('||to_char(trengas.alkamisaika,'DD.MM.YYYY')||'-'||
	to_char(trengas.loppumisaika,'DD.MM.YYYY')||')');
   END LOOP;
   
   htp.ulistclose;
   
   htp.tableopen(NULL,'center');
   htp.tableheader('Renkaat');
   htp.tableheader('Lhtien');
   htp.tableheader('Asti');
   
   htp.tablerowopen;
   htp.p('<td>');
   rengasselect('rengaskoodi','Uusi rengastoimittaja');
   htp.p('</td><td>');
   htp.formtext('rengasalku',13,13,NULL,'onBlur="datecheck(this)"');
   htp.p('</td><td>');
   htp.formtext('rengasloppu',13,13,NULL,'onBlur="datecheck(this)"');
   htp.p('</td>');
   htp.tablerowclose;
   htp.tableclose;

   htp.tableopen(NULL,'center');
   htp.tablerowopen;
   htp.p('<td colspan=50 >');
   IF tkoodi >= 0 THEN
      htp.formsubmit('tnappi','Pivit');
      htp.p('<td colspan=50>');
      htp.formsubmit('tnappi','Poista');
   ELSE
      htp.formsubmit('tnappi','Lis');
   END IF;
   
   htp.p('<td colspan=50>');
   htp.formreset('Peruuta','onClick=javascript:history.go(-1)');
   htp.tablerowclose;
   htp.tableclose;
   htp.formclose;
   
   paate ;

EXCEPTION
   WHEN no_data_found THEN
     htp.p('Hakemaasi tallia ei en lydy tietokannasta. Se on joko ');
     htp.p('poistettu tai olet saanut jostain vanhentuneen linkin.');
     htp.para ;
     htp.p('Tll hetkell kannassa olevat kilpatallit lydt ');
     htp.anchor('ops$kpalin.tallimuokk','tallienksittelyn');
     htp.p(' psivulta');
     paate;
   WHEN OTHERS THEN
     htp.p('<h3>Proseduuri tallisyott suoritus pttyi virheeseen:</h3>');
     htp.p('<font color=red>'|| sqlerrm || '</font>');
END;
/
show errors
  GRANT execute ON tallisyott TO www_user;
EXIT
  
