CREATE OR replace PROCEDURE tallit
IS
   cursor kaikkit IS SELECT talli.koodi,talli.nimi,
     sum(pisteet) yhtp
     FROM kuljettaja k,talli,tallisarja,kilpailu kplu,aika,tulos
     WHERE  
     tulos.kuljettaja=k.koodi AND
     tulos.kilpailu=kplu.koodi AND
     tallisarja.sarjakoodi=kplu.sarja AND 
     tallisarja.tallikoodi=talli.koodi AND 
     aika.tyyppi=(SELECT tyyppi FROM aikasuhteet 
     WHERE ensimmainen='kuljettaja' AND toinen='talli') AND
     aika.alkamisaika<kplu.aajo AND 
     (aika.loppumisaika IS NULL OR aika.loppumisaika>kplu.kilpailu)
     AND aika.ekakoodi=k.koodi AND 
     aika.tokakoodi=talli.koodi
     GROUP BY talli.koodi,talli.nimi
     ORDER BY sum(pisteet) DESC ;


   --cursor kaikkit IS SELECT talli.nimi,talli.koodi FROM talli;
   
   counter INTEGER;
   TYPE taustavari IS TABLE OF VARCHAR2(20) INDEX BY binary_integer;
   taustat taustavari;
   tsarja INTEGER;
   tama kaikkit%ROWTYPE;
BEGIN
   -- Hieno kysely menossa olevan sarjan valinnaksi.
   BEGIN 
      SELECT k.sarja INTO tsarja FROM kilpailu k 
	WHERE ABS(sysdate-k.kilpailu)= (SELECT min(ABS(sysdate-a.kilpailu)) FROM
	kilpailu a );
   EXCEPTION
      WHEN no_data_found THEN
	tsarja:=NULL;
   END;
   
   
   taustat(2):='bgcolor=#99cccc';
   taustat(1):=NULL;
   otsikko('Formula-1 tallit kautta aikain');
   
   htp.tableopen(NULL,NULL,NULL,NULL,'width=90% border=4');
   htp.tabledata('<a href=ops$kpalin.kalenteri?skoodi='||tsarja||'>Kalenteri</a>','center');
   htp.tabledata('<a href=ops$kpalin.sarjasivu?skoodi='||tsarja||'>Sarja</a>','center');
   htp.tabledata('<a href=ops$kpalin.uutiset>Uutiset</a>','center');
   htp.tabledata('<a href=ops$kpalin.kuljettajat>Kuljettajat</a>','center');
   htp.tableclose;
   htp.line;
   
   htp.p('Seuraavat tallit ovat joskus kilpailleet Formula-1 sarjassa:');
   
   htp.tableopen(NULL,'center',NULL,NULL,'width=75%');
   
   htp.tableheader('Nimi');
   htp.tableheader('Pisteit');
   
   counter:=1;
   
   FOR tama IN kaikkit LOOP
      htp.tablerowopen;
      htp.tabledata('<a href=ops$kpalin.tallisivu?tkoodi='||tama.koodi||'>'||
	tama.nimi||'</a>',NULL,NULL,NULL,NULL,NULL,taustat(MOD(counter,2)+1));
      htp.tabledata(tama.yhtp,NULL,NULL,NULL,NULL,NULL,taustat(MOD(counter,2)+1));
      htp.tablerowclose;
      counter:=counter+1;
   END LOOP;
   htp.tableclose;

   paate;
EXCEPTION
   WHEN OTHERS THEN
     htp.p('<h3>Proseduuri uutiset tallit pttyi virheeseen:</h3>');
     htp.p('<font color=red>'|| sqlerrm || '</font>');
END;
/
show errors
  GRANT execute ON tallit TO www_user;
EXIT
