CREATE OR replace PROCEDURE uutiset
IS
   cursor menestys IS SELECT k.koodi,k.enimi,k.snimi,k.saika,k.spaikka,
     k.kaika,k.kpaikka,k.kansalaisuus,k.kotipaikka,talli.nimi tnimi,pisteet,
     ktulos,talli.koodi tkoodi
     FROM kuljettaja k,talli,tallisarja,kilpailu kplu,aika,tulos
     WHERE  kplu.kilpailu<sysdate AND 
     (sysdate-kplu.kilpailu)= (SELECT min(sysdate-a.kilpailu) FROM
     kilpailu a WHERE a.kilpailu<sysdate)
     AND tulos.kuljettaja=k.koodi AND
     tulos.kilpailu=kplu.koodi AND
     tallisarja.sarjakoodi=kplu.sarja AND 
     tallisarja.tallikoodi=talli.koodi AND 
     aika.tyyppi=(SELECT tyyppi FROM aikasuhteet 
     WHERE ensimmainen='kuljettaja' AND toinen='talli') AND
     aika.alkamisaika<kplu.aajo AND 
     (aika.loppumisaika IS NULL OR aika.loppumisaika>kplu.kilpailu)
     AND aika.ekakoodi=k.koodi AND 
     aika.tokakoodi=talli.koodi
     ORDER BY tulos.ktulos;
   
   cursor laiska IS SELECT kilpailu.koodi,aajo,kilpailu,sarja,nimi,sijainti pituus,ennatys,vvuosi,sijainti FROM  kilpailu,rata;
   seurkilpa laiska%ROWTYPE;
   edkilpa laiska%ROWTYPE;
   ajaja menestys%ROWTYPE;
   counter INTEGER;
   vaika NUMBER;
   TYPE taustavari IS TABLE OF VARCHAR2(20) INDEX BY binary_integer;
   taustat taustavari;
   tsarja INTEGER;
BEGIN
   -- Hieno kysely menossa olevan sarjan valinnaksi.
   BEGIN 
      SELECT k.sarja INTO tsarja FROM kilpailu k 
	WHERE ABS(sysdate-k.kilpailu)= (SELECT min(ABS(sysdate-a.kilpailu)) FROM
	kilpailu a );
   EXCEPTION
      WHEN no_data_found THEN
	tsarja:=NULL;
   END;
   
   BEGIN 
      SELECT  k.koodi,aajo,kilpailu,sarja,nimi,sijainti pituus,ennatys,vvuosi,sijainti 
	INTO edkilpa 
	FROM kilpailu k ,rata r
	WHERE k.kilpailu<sysdate AND k.rata=r.koodi AND 
	(sysdate-k.kilpailu)= (SELECT min(sysdate-a.kilpailu) FROM
	kilpailu a WHERE a.kilpailu<sysdate);
   EXCEPTION
      WHEN no_data_found THEN
	edkilpa.koodi:=NULL;
   END;
   
   BEGIN 
      SELECT k.koodi,aajo,kilpailu,sarja,nimi,sijainti pituus,ennatys,vvuosi,sijainti
	INTO seurkilpa 
	FROM kilpailu k,rata r 
	WHERE k.kilpailu>=sysdate AND k.rata=r.koodi AND
	(sysdate-k.kilpailu)= (SELECT max(sysdate-a.kilpailu) FROM
	kilpailu a WHERE a.kilpailu>=sysdate);
   EXCEPTION
      WHEN no_data_found THEN
	seurkilpa.koodi:=NULL;
   END;

   otsikko('Formula-1 Tulospalvelu');
   htp.tableopen(NULL,NULL,NULL,NULL,'width=90% border=4');
   htp.tabledata('<a href=ops$kpalin.kalenteri?skoodi='||tsarja||'>Kalenteri</a>','center');
   htp.tabledata('<a href=ops$kpalin.sarjasivu?skoodi='||tsarja||'>Sarja</a>','center');
   htp.tabledata('<a href=ops$kpalin.tallit>Tallit</a>','center');
   htp.tabledata('<a href=ops$kpalin.kuljettajat>Kuljettajat</a>','center');
   htp.tableclose;
   htp.line;
   
   htp.tableopen(NULL,NULL,NULL,NULL,'width=90%');
   htp.tablerowopen;
   htp.tabledata('Edellinen kilpailu:');
   htp.tabledata('Viimeisimmt tulokset: '||to_char(edkilpa.kilpailu,'DD.MM.YYYY'));
   htp.tablerowclose;
   htp.tablerowopen;
   htp.tabledata('<a href=ops$kpalin.kilpailusivu?kkoodi='||edkilpa.koodi||'>'||
     edkilpa.sijainti||'</a>');
   htp.tabledata(edkilpa.nimi||' ('||edkilpa.sijainti||')');
   htp.tablerowclose;
   htp.tablerowopen;
   htp.tabledata('Seuraava kilpailu:');
   htp.tabledata('Rataenntys: '||aikamuoto(edkilpa.ennatys));
   htp.tablerowclose;
   htp.tablerowopen;
   htp.tabledata('<a href=ops$kpalin.kilpailusivu?kkoodi='||seurkilpa.koodi||'>'||
     seurkilpa.sijainti||'</a>');
   htp.tabledata;
   htp.tablerowclose;
   
   counter:=1;
   
   BEGIN 
      SELECT min(ktulos)
	INTO vaika 
	FROM tulos 
	WHERE kilpailu=edkilpa.koodi;
   EXCEPTION
      WHEN no_data_found THEN
	vaika:=NULL;
   END;
   taustat(1):='bgcolor=#c0c0c0';
   taustat(2):='bgcolor=#99cccc';
   taustat(1):=NULL;
   
   FOR ajaja IN menestys LOOP
      htp.tablerowopen;
      htp.tabledata;
      htp.tabledata(counter||'. <a href=ops$kpalin.kuljettajasivu?kkoodi='||
	ajaja.koodi||'>'||ajaja.enimi||' '||ajaja.snimi||
	'</a> (<a href=ops$kpalin.tallisivu?tkoodi='||ajaja.tkoodi||'>'
	||ajaja.tnimi||') ',NULL,NULL,NULL,NULL,NULL,taustat(MOD(counter,2)+1));
      htp.tabledata(ajaja.pisteet||'p','right',NULL,NULL,NULL,NULL,taustat(MOD(counter,2)+1));
      IF counter=1 THEN
	 htp.tabledata(aikamuoto(ajaja.ktulos),'right',NULL,NULL,NULL,NULL,taustat(MOD(counter,2)+1));
      ELSE
	 htp.tabledata('+'||ops$kpalin.aikamuoto(ajaja.ktulos-vaika),'right',NULL,NULL,NULL,NULL,taustat(MOD(counter,2)+1));
      END IF;
      
      htp.tablerowclose;
      counter:= counter+1;
   END LOOP;
   
   htp.tableclose;
   paate;
EXCEPTION
   WHEN OTHERS THEN
     htp.p('<h3>Proseduuri uutiset suoritus pttyi virheeseen:</h3>');
     htp.p('<font color=red>'|| sqlerrm || '</font>');
END;
/
show errors
  GRANT execute ON uutiset TO www_user;
EXIT





